# Run the specified method.

suppressMessages({
  library(R.utils)
  library(jsonlite)
})

# Get the passed arguments from the command line via Snakemake.
args <- commandArgs(trailingOnly = TRUE, asValues = TRUE)

# Debugging
print(args)

# Extract the elements of the passed argument.
sim_data <- readRDS(args$sim)
meth_pars <- as.list(fromJSON(args$meth_pars))
# TODO: Improve argument names. These come from the snakefile.
method_file <- args$fun
result_file <- args$res

# In this project the file run_{method} will contain a function `run_{method}`
# which takes two arguments: a SingleCellExperiment object and a named list of
# parameters/arguments for the method.
source(method_file)
func <- gsub("(.R)", "", basename(method_file))
func <- gsub("-", "_", func)
result <- get(func)(sim_data, meth_pars)

# TODO: Add more context the the result.

# Save the results.
saveRDS(result, result_file)
